(function ($) {
    
    // Toggle Search Area
    var toggle = function toggleF(triggerSelector, toggleAreaSelector) {
        $(triggerSelector).click(function (e) {
            var $selected = $(this);

            e.preventDefault();

            if ($selected.attr("aria-selected") === "true") {
                $selected
                    .attr("aria-selected", "false");

                $(toggleAreaSelector)
                    .attr("aria-hidden", "true")
                    .attr("aria-expanded", "false")
                    .addClass('noDisplay');
            } else {
                $selected
                    .attr("aria-selected", "true");

                $(toggleAreaSelector)
                    .attr("aria-hidden", "false")
                    .attr("aria-expanded", "true")
                    .removeClass('noDisplay');
            }
        });
    };

    // Toggle areas using triggers and areas - first 5 characters are removed so find the related area
    // If the toggle area is too big, default it to closed
    var toggleArea = function toggleAreaF(trigger) {

        $(".toggle-trigger").each(function() {
            var $toggleTrigger = $(this);
            var $toggleArea = $('#' + $toggleTrigger.attr('aria-controls'));
            var maxHeight = 300;

            if ($toggleArea.height() > maxHeight) {

                $toggleTrigger.attr("aria-selected", "false").toggleClass("toggle-closed");
                

                $toggleArea
                    .attr("aria-hidden", "true")
                    .attr("aria-expanded", "false")
                    .addClass('noDisplay');
            }
        });

        $(trigger).click(function(e) {
            var $selected = $(this);
            var $toggle = $('#' + $selected.attr('aria-controls'));

            e.preventDefault();

            $selected
                .toggleAttr("aria-selected", ["true", "false"])
                .toggleClass("toggle-closed");

            $toggle
                .toggleAttr("aria-hidden", ["false", "true"])
                .toggleAttr("aria-expanded", ["true", "false"])
                .slideToggle(500);
        });
    };

    $(function () {
        /*$('#siteSections').select2();*/

        //window.addthis.init();

        if ($('.accordion, .tabs').length) {
            //Tabs
            $('.accordion, .tabs').TabsAccordion({
                hashWatch: true,
                pauseMedia: true,
                responsiveSwitch: 'tablist',
                saveState: window.sessionStorage
            });
        }

        $('.subNav .children').click(function (e) {
            $(this).toggleClass('open').siblings('ul').toggleClass('display').slideToggle(200);
        });

        $('.subNav .hider').click(function (e) {
            e.preventDefault();
            $(this).parent('.subNav').toggleClass('hide').siblings('.content').toggleClass('expand');
            setTimeout(function () {
                $(window).trigger('resize');
            }, 1000);
        });

        $('figcaption').click(function (e) {
            $(this).parent('figure').toggleClass('expand');
        });

        toggle('.toggle-button', '#expand-results');

        setTimeout(function() {
            $('.subNav .current').next('.children').trigger('click');
        }, 0);


    });// close doc ready	
    
    $(window).load(function () {
        toggleArea('.toggle-trigger');
    });
    
})(jQuery);