﻿(function (ng) {
    angular.module('mapModule')
	    .factory('GoogleMapService', ['$http', function ($http) {
	        var googleMapService = {
	            getRegionNames: function () { return serviceCall(true, '/api/map/GetRegionNames', 'GET', ''); },
	            getTags: function () { return serviceCall(true, '/api/map/GetTags', 'GET', ''); },
	            getAllPlaces: function () { return serviceCall(true, '/api/map/GetPlaces', 'GET', ''); },
	            getPlaces: function (json) { return serviceCall(false, '/api/map/GetPlaces', 'POST', json); },
	            getPlacesNames: function () { return serviceCall(true, '/api/map/GetPlacesNames', 'GET', ''); }
	        };

	        function serviceCall(cacheParam, urlParam, crudType, dataParam) {
	            return $http({ cache: cacheParam, dataType: 'json', url: urlParam, method: crudType, data: dataParam })
                                .then(function (response) {
                                    return response.data;
                                });
	        }

	        return googleMapService;
	    }]);
})(angular);