﻿(function (ng, $) {
    // NavigationService - gets the nav async from a service (e.g. Web API) 
    // and stores the results in HTML5 session/local storage
    angular.module('mobileNav')
        // Swap 'SessionStorage' here for 'LocalStorage' to use local storage instead
        .factory('NavigationService', ['$http', 'SessionStorage', function ($http, storage) {
            var storageId = "nzhpt-nav-storage";

            var navigationService = {
                getNavAsync: function () {
                    // $http returns a promise, which has a then function, which also returns a promise
                    var promise = $http.get("/api/cms/GetMobileNav")
                        .then(function (response) {
                            storage.put(response.data, storageId);
                            // The then function here is an opportunity to modify the response
                            // The return value gets picked up by the then in the controller.
                            return response.data;
                        });
                    // Return the promise to the controller
                    return promise;
                },
                getNavFromStorage: function () {
                    return storage.get(storageId);
                },
                navInStorage: function () {
                    return storage.get(storageId).length > 0;
                },
                storageMedium: storage.friendlyName
            };

            return navigationService;
        }]);
})(angular, window.jQuery || angular.element);