﻿// Todo: Way too much logic in this controller, refactor out to additional services
(function () {
    angular.module('search')
        .controller('RegisterSearchCtrl', ['$scope', '$http', '$timeout', '$window', 'RegisterSearchService', 'utils', '$q',
        function ($scope, $http, $timeout, $window, RegisterSearchService, utils, $q) {
            var userLocationDeferred = $q.defer();
            var userLocationIsSet = userLocationDeferred.promise;
            var allLocalAuthority = [];
            $scope.isButtonSearch = false;
            userLocationIsSet.then(function () {
                checkForPassedQueryStrings();
            });

            $scope.displayTooltip = function (prop) {
                $scope[prop] = !$scope[prop];

                if ($scope[prop]) {
                    $window.onclick = function (event) {
                        if (event.target.id != prop) {
                            $scope.$apply(function () {
                                $scope[prop] = false;
                            });
                        }
                    };
                }
            };

            $scope.searchService = {};

            $scope.searchData = RegisterSearchService.searchData();

            // Object to hold all out Web API filter options
            // This object gets populate async
            $scope.selectOptions = {};

            $scope.select2 = RegisterSearchService.select2Options();

            $scope.registerGoogleMap = {
                userLocation: {},
                zoomLevel: {},
                curMapCenter: {},
                isAutoSearch: false,
            };

            $scope.searchedTerm = "";
            $scope.searchPerformed = false;
            $scope.showNoResultsMessage = false;

            $scope.getSearchResults = function () {
                $scope.registerGoogleMap.keepZoom(false);
                $scope.isButtonSearch = true;
                $scope.showRangeMessage = false;
                $scope.registerGoogleMap.setZoomSearchFlag(false);
                searchResults();
            };

            function searchResults() {
                if ($scope.noValidSearchData()) {
                    return;
                }

                $scope.searchData.searchedTerm = $scope.searchData.search;
                $scope.searchService = new RegisterSearchService.getInstance($scope.searchData);

                // Update map only when we have results back and user's location is set
                var readyToSearch = $q.all($scope.searchService.getAllRegisterSearchResults(), userLocationIsSet);

                var bounds;
                // If initial search then get all map markers
                readyToSearch.then(function () {

                    $scope.searchData.lat = 0;
                    $scope.searchData.lng = 0;

                    if ($scope.searchService.totalResultsCount > 0) {
                        updateResultsForSearchType();

                        if ($scope.isButtonSearch) {
                            $scope.previousSearchResults = $scope.searchService.allResults;
                            $scope.registerGoogleMap.options.directMatchItem = $scope.previousSearchResults[0].RegisterNumber;
                            if ($scope.searchData.address && $scope.searchData.address != '') {
                                if ($scope.registerGoogleMap.options.currentAddressSearchResult == null)
                                    $scope.registerGoogleMap.options.currentAddressSearchResult = $scope.searchService.allResults[0];
                            }
                        } else {
                            //remove result items whic outside the map bounds, only leave rehersults that inside the map rectangle
                            //bounds = $scope.registerGoogleMap.getMapBounds();
                            //angular.forEach($scope.searchService.allResults, function (item, index) {
                            //    var position = new google.maps.LatLng(item.Lat, item.Lng);
                            //    if (bounds.contains(position) == false) {
                            //        $scope.searchService.allResults.splice(index, 1);
                            //    }
                            //});
                            
                            if ($scope.registerGoogleMap.options.currentAddressSearchResult) {
                                $scope.searchService.allResults.push($scope.registerGoogleMap.options.currentAddressSearchResult);
                            }
                        }
                        
                        // Update map with results from Web API request
                        $scope.registerGoogleMap.addNewLocationMarkers($scope.searchService.allResults);
                        $scope.showRangeMessage = !$scope.isButtonSearch;
                        //
                        if ($scope.registerGoogleMap.getZoomLevel() > 14 && $scope.isButtonSearch && ($scope.searchData.address == null || $scope.searchData.address == '')) {
                            $scope.registerGoogleMap.setZoomLevel(14);
                        }
                        // Prime our service results for loading the additional pages by scroll
                        $scope.searchData.searchResultsCount = $scope.isButtonSearch ? $scope.searchService.totalResultsCount : $scope.searchService.allResults.length;
                        $scope.searchData.requestedUrl = $scope.searchService.requestedUrl;
                        $scope.showNoResultsMessage = false;

                        //if (attachPreviousResults && $scope.previousSearchResults && $scope.previousSearchResults.length > 0) {
                        //    $scope.registerGoogleMap.addNewLocationMarkers($scope.previousSearchResults);
                        //}
                    } else {
                        $scope.registerGoogleMap.clearMap();
                        $scope.searchData.searchResultsCount = 0;
                        $scope.showNoResultsMessage = true;
                    }
                    
                    if (($scope.searchService.allResults == null || $scope.searchService.allResults.length == 0) && ($scope.previousSearchResults == null || $scope.previousSearchResults.length == 0))
                        $scope.showRangeMessage = false;
                    
                    $scope.searchPerformed = true;

                    //zoomLevelListener();
                    //curMapCenterListener();
                    $scope.registerGoogleMap.isAutoSearch = false;
                });

            };

            $scope.clearForm = function (isClearPreviousResults) {
                
                $scope.showNoResultsMessage = false;
                $scope.selectOptions.localAuthorities = allLocalAuthority;
                $scope.registerGoogleMap.clearMap();

                $scope.showRangeMessage = false;
                
                if (isClearPreviousResults) {
                    if ($scope.previousSearchResults)
                        $scope.previousSearchResults.length = 0;
                    $scope.searchData = RegisterSearchService.searchData();
                    $scope.registerGoogleMap.options.directMatchItem = null;
                    $scope.searchService = {};
                    $scope.registerGoogleMap.options.currentAddressSearchResult = null;
                } else {
                    $scope.registerGoogleMap.keepZoom(true);
                    if ($scope.previousSearchResults) {
                        $scope.searchService.pagedResults = $scope.previousSearchResults;
                        $scope.searchService.allResults = $scope.previousSearchResults;
                        $scope.registerGoogleMap.addNewLocationMarkers($scope.previousSearchResults);
                        $scope.searchData.searchResultsCount = $scope.previousSearchResults.length;
                    } else {
                        if ($scope.searchService.pagedResults)
                            $scope.searchService.pagedResults.length = 0;
                        if ($scope.searchService.allResults)
                            $scope.searchService.allResults.length = 0;
                        $scope.searchData.searchResultsCount = 0;
                    }
                    $scope.showNoResultsMessage = false;
                    $scope.showRangeMessage = false;
                }
            };

            $scope.noValidSearchData = function () {
                return !$scope.searchData.validSearchData();
            };

            $scope.pauseSearch = function () {
                return !!($scope.searchPerformed === false || $scope.searchService.busy);
            };

            $scope.hasSearchResults = function () {
                return $scope.searchPerformed && !$scope.loadingAsyncResults();
            };

            $scope.loadingAsyncResults = function () {
                return $scope.searchService.busy;
            };

            $scope.noResults = function () {
                return $scope.searchPerformed && $scope.searchData.searchResultsCount === 0 && $scope.showNoResultsMessage;
            };

            $scope.getRegisterName = function (name) {
                return name == "Taumatawhakatangihangakoauauotamateaturipukakapikimaungahoronukupokaiwhenuakitanatahu"
                    ? "Taumatawhakatangihangakoauauotamatea turipukakapikimaungahoronukupokaiwhenua\nkitanatahu"
                    : name;
            };

            populateSearchFilterOptionsAsync();
            addWatchFunctions();

            function updateResultsForSearchType() {
                // Update the first icon in the results to reflect the type of search
                $scope.registerGoogleMap.options.firstResultMarkerPath = firstResultMarkerIcon($scope.searchData);

                function firstResultMarkerIcon(searchData) {
                    if (searchData.address) {
                        return "/content/images/icon-google.png";
                    } else if ((searchData.search && searchData.search.length) ||
                            (searchData.place && searchData.place.length) ||
                            (searchData.townCity && searchData.townCity.length)) {

                        return "/content/images/icon-direct-match.png";
                    }
                    return "/content/images/icon-register.png";
                };
            }

            function populateSearchFilterOptionsAsync() {
                RegisterSearchService.getRegions().then(function (data) {
                    $scope.selectOptions.regions = data;
                });

                RegisterSearchService.getGroupedUses().then(function (data) {
                    $scope.selectOptions.groupedUses = data;
                });

                RegisterSearchService.getLocalAuthority().then(function (data) {
                    $scope.selectOptions.localAuthorities = data;
                    allLocalAuthority = data;
                });

                RegisterSearchService.getRegistrationType().then(function (data) {
                    $scope.selectOptions.registrationTypes = data;
                });

            }

            function addWatchFunctions() {
                // Add users location to searchData model when found
                $scope.$watch('registerGoogleMap.userLocation', function (userLocation) {
                    //userLocation && userLocation.lat && userLocation.lng
                    if (!utils.isEmpty(userLocation)) {
                        $scope.searchData.userLocationLat = userLocation.lat;
                        $scope.searchData.userLocationLng = userLocation.lng;
                        userLocationDeferred.resolve();
                    }
                }, true);

                // supp 97
                var zoomLevelListener = $scope.$watch('registerGoogleMap.currentZoomLevel', function (zoomLevel) {
                    var autoSearch = $scope.registerGoogleMap.isAutoSearch;
                    if (zoomLevel > 14 && autoSearch) {
                        $scope.isButtonSearch = false;
                        var center = $scope.registerGoogleMap.curMapCenter;
                        $scope.searchData.lat = center.lat();
                        $scope.searchData.lng = center.lng();
                        searchResults();
                    } else if ($scope.isButtonSearch == false) {
                        $scope.clearForm(false);
                    }
                }, true);

                var curMapCenterListener = $scope.$watch('registerGoogleMap.curMapCenter', function (center) {
                    var autoSearch = $scope.registerGoogleMap.isAutoSearch;
                    if ($scope.registerGoogleMap.currentZoomLevel > 14 && autoSearch) {
                        $scope.isButtonSearch = false;
                        $scope.searchData.lat = center.lat();
                        $scope.searchData.lng = center.lng();
                        searchResults();
                    }
                }, true);

                $scope.$watch('searchData.address', function (address) {
                    if (!address) {
                        $scope.searchData.lat = 0;
                        $scope.searchData.lng = 0;
                        $scope.searchData.googleAutoCompleteResults = {};
                    } else {
                        $scope.searchData.lat = $scope.searchData.googleAutoCompleteResults.lat;
                        $scope.searchData.lng = $scope.searchData.googleAutoCompleteResults.lng;
                    }
                });

                $scope.$watch('searchData.chooseARegion', function (regions) {
                    if (!angular.isArray(regions) || !regions.length) {
                        $scope.selectOptions.localAuthorities = allLocalAuthority;
                        return;
                    }

                    RegisterSearchService.getLocalAuthorityByRegion(regions).then(function (data) {
                        $scope.selectOptions.localAuthorities = data;
                    });

                });
            }

            // If query string are passed them get them and trigger the search
            function checkForPassedQueryStrings() {
                if (utils.qs.isEmpty) {
                    return;
                }

                $scope.searchData.constructionProfessional = utils.qs.constprof;
                $scope.searchData.theme = utils.qs.theme;
                if (utils.qs.uses) {
                    $scope.searchData.uses[0] = utils.qs.uses;
                }

                $scope.getSearchResults();
            };

        }]);
}());