﻿(function (ng) {
    angular.module('storage')
        .factory('SessionStorage', ['$window', function ($window) {
            return {
                get: function (storageId) {
                    return angular.fromJson($window.sessionStorage.getItem(storageId) || '[]');
                },
                put: function (object, storageId) {
                    $window.sessionStorage.setItem(storageId, angular.toJson(object));
                },
                friendlyName: "session storage"
            };
        }])
        .factory('LocalStorage', ['$window', function ($window) {
            return {
                get: function (storageId) {
                    return angular.fromJson($window.localStorage.getItem(storageId) || '[]');
                },
                put: function (object, storageId) {
                    $window.localStorage.setItem(storageId, angular.toJson(object));
                },
                friendlyName: "local storage"
            };
        }]);
})(angular);